package badger

import (
	"git.frostfs.info/TrueCloudLab/frostfs-node/pkg/local_object_storage/kvio"
	badger "github.com/dgraph-io/badger/v4"
)

type cursor struct {
	it *badger.Iterator
}

func (c cursor) Key() kvio.Key {
	if c.it.Valid() {
		return c.it.Item().Key()
	}
	return nil
}

func (c cursor) Rewind()         { c.it.Rewind() }
func (c cursor) Seek(k kvio.Key) { c.it.Seek(k) }
func (c cursor) Next()           { c.it.Next() }
func (c cursor) Close()          { c.it.Close() }

func (c cursor) Value(f func(kvio.Value) error) error {
	if c.it.Valid() {
		return c.it.Item().Value(func(val []byte) error {
			return f(val)
		})
	}
	return f(nil)
}
